/**********************************************************************/
/* PMDRC - P.M.D. reversal compiler by JUD(T.Terata)                  */
/* Utility functions                                                  */
/**********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

#include "fpd.h"
#include "fpdext.h"


/*--------------------------------------------------------------------*/
/*  AhX̃X^bN */
/* arg. NULL:Wv other:X^bN */
char *stackaddr( char *cp_getm ){

static char *cp_mtb=NULL;
static char **cpp_mcur=NULL;
static int i_mtbcount=0;
static int i_mtbsize=0;
static int i_mtbunit=0;
	char *cp_tmp;
	char **cpp_tmp;
	char *cp_ret;
	int i_count;
	int i_doublecount;
	char **cpp_sorter;
	char **cpp_nsorter;
	char **cpp_scur=NULL;
long *lp_tmp;

	/* Wv̏ꍇ */
	if( cp_getm == NULL ){
		/* {EEEEĐĂǁ[񂾁H */
		/* Ƃ肠A邮񂷂ȂEEEEE */
		if( i_mtbcount == 0 ){
			/* PȂꍇ */
			return( NULL );
		}
		if( i_mtbcount > 1 ){
			/* Qȏ゠ꍇ͐ */
			for(i_doublecount=0;i_doublecount<(i_mtbcount-1);i_doublecount++){
				cpp_scur = (char **)cp_mtb;
				for(i_count=0;i_count<(i_mtbcount-1);i_count++){
					cpp_sorter = cpp_scur;
					cpp_scur++;
					cpp_nsorter = cpp_scur;
					if( *cpp_sorter > *cpp_nsorter ){
						/* Ԃւ */
						cp_tmp = *cpp_nsorter;
						*cpp_nsorter = *cpp_sorter;
						*cpp_sorter = cp_tmp;
					}
				}
			}
		}

		/* ƁAVapmallocŎ蒼Ȃƃ}YC */
		cp_ret = apmalloc( sizeof(char *) * (i_mtbcount+1) );
		memset( cp_ret , 0x00 , sizeof(char *) * (i_mtbcount) );
		memcpy( cp_ret , cp_mtb , sizeof(char *) * (i_mtbcount) );
//		apfree( cp_mtb );

		/* staticϐ̏ */
		cp_mtb=NULL;
		cpp_mcur=NULL;
		i_mtbcount=0;
		i_mtbsize=0;
		i_mtbunit=0;

		/* Ԃ̂(char *) */
		return( cp_ret );
	}

	/* ̊蓖ĂKvȏꍇ */
	if( cp_mtb == NULL && i_mtbcount == 0 ){
		/* 蓖 */
		cp_mtb = apmalloc( (1+DN_SIZE_STACKUNIT) * (sizeof(char *)) );
		cpp_mcur = (char **)(cp_mtb);
		i_mtbcount = 0;
		i_mtbunit = 1;
		i_mtbsize = DN_SIZE_STACKUNIT * sizeof(void *);
	}else if( i_mtbcount > 0 && i_mtbcount % DN_SIZE_STACKUNIT == 0 ){
		/* Ċ蓖 */
		i_mtbunit++;
		cp_tmp = apmalloc( (1+DN_SIZE_STACKUNIT*i_mtbunit) * (sizeof(char *)) );
		memcpy( cp_tmp , cp_mtb ,
			(1+DN_SIZE_STACKUNIT*(i_mtbunit-1)) * (sizeof(char *)) );
//		apfree( cp_mtb );
		cp_mtb = cp_tmp;
		cpp_mcur = (char **)(cp_mtb);
		cpp_mcur += i_mtbcount;
		i_mtbsize += DN_SIZE_STACKUNIT * sizeof(char *);
	}

	/* 擾AhXX^bN */
	*cpp_mcur = cp_getm;
	i_mtbcount++;
	cpp_mcur++;

	return( NULL );
}
/*--------------------------------------------------------------------*/
/* [eBeB */
/* ׂ */
int powxy(int x,int y){
	int i_loop;
	int	i_ans;

	i_ans = 1;
	for(i_loop=0;i_loop<y;i_loop++){
		i_ans = i_ans * x;
	}
	return( i_ans );
}
/*--------------------------------------------------------------------*/
/* ꊇ⏕֐ */
/*  arg.  -1:Rerease  0-:size */
void *apmalloc( int i_size ){

static void *vp_mtb=NULL;
static void **vpp_mcur=NULL;
static int i_mtbcount=0;
static int i_mtbsize=0;
static int i_mtbunit=0;
	void *vp_tmp;
static void *vp_getm;
	int i_count;

	/* ̏ꍇ */
	if( i_size == -1 ){
		if( i_mtbcount == 0 ){
			/* тȂ̂ŉȂ */
			return( NULL );
		}
		/* { */
		vpp_mcur = vp_mtb;
		for(i_count=0;i_count<i_mtbcount;i_count++){
			if( *vpp_mcur != NULL ){
				apfree( *vpp_mcur );
			}
			vpp_mcur++;
		}
		/* ŌɎgŎgpĂ郁[X */
		apfree( vp_mtb );
		return( NULL );
	}

	/* 擾{ */
	vp_getm = malloc( i_size );
	if( vp_getm == NULL ){
		return( NULL );
	}

	/* ̊蓖ĂKvȏꍇ */
	if( vp_mtb == NULL && i_mtbcount == 0 ){
		/* 蓖 */
		vp_mtb = malloc( (1+DN_SIZE_MTBUNIT) * (sizeof(void *)) );
		vpp_mcur = (void *)(vp_mtb);
		i_mtbcount = 0;
		i_mtbunit = 1;
		i_mtbsize = DN_SIZE_MTBUNIT * sizeof(void *);
	}else if( i_mtbcount > 0 && i_mtbcount % DN_SIZE_MTBUNIT == 0 ){
		/* Ċ蓖 */
		i_mtbunit++;

//		vp_tmp = malloc( (1+DN_SIZE_MTBUNIT*i_mtbunit) * (sizeof(void *)) );
//		memcpy( vp_tmp , vp_mtb ,
//			(1+DN_SIZE_MTBUNIT*(i_mtbunit-1)) * (sizeof(void *)) );
//		apfree( vp_mtb );
//		vp_mtb = vp_tmp;
		vp_mtb = realloc( vp_mtb ,
			(1+DN_SIZE_MTBUNIT*i_mtbunit) * (sizeof(void *)) );
//
		vpp_mcur = (void *)(vp_mtb);
		vpp_mcur += i_mtbcount;
		i_mtbsize += DN_SIZE_MTBUNIT * sizeof(void *);
	}

	/* 擾AhXX^bN */
	*vpp_mcur = vp_getm;
	i_mtbcount++;
	vpp_mcur++;

	return( vp_getm );
}
/*--------------------------------------------------------------------*/
/* o͕⏕֐ */
/*  arg.1  -1:init  0-(DN_MAX_F2POUTBUFFER-1):handle */
/*  arg.2  o͕ւ̃|C^ ԋpl NULL: cp_in:ُ */
/*         NULL:Ynh̃obt@擪AhXԋp */
int apfree( void *vp_in ){

	int i_ret;

	if( vp_in != NULL ){
		free( vp_in );
	}

	return( 0 );
}
/*--------------------------------------------------------------------*/
/* o͕⏕֐ */
/*  arg.1  -1:init  0-(DN_MAX_F2POUTBUFFER-1):handle */
/*  arg.2  o͕ւ̃|C^ ԋpl NULL: cp_in:ُ */
/*         NULL:Ynh̃obt@擪AhXԋp */
char *hfpf( int i_handle , char *cp_in ){

static int is_outbuffersize[DN_MAX_F2POUTBUFFER];
static int is_cursize[DN_MAX_F2POUTBUFFER];
static char *cps_cur[DN_MAX_F2POUTBUFFER];
static char *cps_buffer[DN_MAX_F2POUTBUFFER];
static int is_unit[DN_MAX_F2POUTBUFFER];
	char *cp_ret;
	int i_count;

	if( i_handle == -1 ){
		/* S */
		for(i_count=0;i_count<DN_MAX_F2POUTBUFFER;i_count++){
			is_outbuffersize[i_count] = 0;
			is_cursize[i_count] = 0;
			cps_cur[i_count] =  NULL;
			cps_buffer[i_count] = NULL;
			is_unit[i_count] = 0;
		}
		sprintf(gcs_line," [F2P] Initialize output-buffers.\n");
		if( (gtp_gop->i_directmes&D_ON) != 0 ){
			/* 䃁bZ[W̃_CNgo͑Ή */
			fprintf(stderr,gcs_line);
		}
		return( NULL );
	}
	/* nh͈͊O */
	if( i_handle < 0 || i_handle >= DN_MAX_F2POUTBUFFER ){
		return( cp_in );
	}

	if( cp_in == NULL ){
		/* enhΉ̃obt@Ԃꍇ */
		return( cps_buffer[i_handle] );
	}

	if( (gtp_gop->i_directmes&D_ON) != 0 && i_handle == DH_BMESSAGES ){
		/* 䃁bZ[W̃_CNgo͑Ή */
		fprintf(stderr,"%s",cp_in);
	}

	/* `FbN */
	if( cp_in != NULL && (strlen(cp_in) >= DN_SIZE_LINEBUFFER) ){
		return( cp_in );
	}

	/* 蓖 */
	if( is_outbuffersize[i_handle] == 0 ){
		/* m() */
		cps_buffer[i_handle] = malloc( DN_MAX_OUTUNITSIZE );
		cps_cur[i_handle] = cps_buffer[i_handle];
		is_unit[i_handle] = 1;
		is_outbuffersize[i_handle] = DN_MAX_OUTUNITSIZE;
	}else if( is_cursize[i_handle]+strlen(cp_in)+1 >
				is_outbuffersize[i_handle] ){
		/* sǉ蓖 */
		is_unit[i_handle]++;
		cp_ret = malloc( DN_MAX_OUTUNITSIZE * is_unit[i_handle] );
		memcpy( cp_ret , cps_buffer[i_handle] ,
			DN_MAX_OUTUNITSIZE * (is_unit[i_handle]-1) );
		apfree( cps_buffer[i_handle] );
		cps_buffer[i_handle] = cp_ret;
		/* Jg|C^Ĕzu */
		cps_cur[i_handle] = cps_buffer[i_handle] + is_cursize[i_handle];
		is_outbuffersize[i_handle] = DN_MAX_OUTUNITSIZE * is_unit[i_handle];
	}
	/* o */
	strcpy( cps_cur[i_handle] , cp_in );
	/* JgTCYZEJg|C^ړE| */
	cps_cur[i_handle] += strlen( cp_in );
	is_cursize[i_handle] += strlen( cp_in );
	if( cp_in != NULL ){
		memset( cp_in , 0x00 , DN_SIZE_LINEBUFFER );
	}

	return( NULL );
}
