#ifndef F2PCVIF_H
/**********************************************************************/
/* FMP -> P.M.D. data converter interface for F2PCV.DLL               */
/**********************************************************************/

#include "comrcif.h"

#ifndef JST_D_ONOFF
#define D_ON 1
#define D_OFF 0
#endif
#define JST_D_ONOFF

/*--------------------------------------------------------------------*/
/* ݒ苤ʒ萔 */

#define D_TYPE_UK 0
#define D_TYPE_OPI 2
#define D_TYPE_OVI 3
#define D_TYPE_OZI 4

#define D_TYPE_06PART 0x20
#define D_TYPE_11PART 0x40

#define DS_F2PFILENAME "f2pcv.dll"
#define DS_F2PFUNCNAME "f2pcv_dllmain"
#define DS_F2PFMFUNCNAME "f2pcv_dllfreem"
/*--------------------------------------------------------------------*/
/* C^[tF[X\ V1.10 */
#define DN_MAX_F2POUTBUFFER 4 /* o̓obt@ */
typedef	struct	_t_f2pif{

	int i_iv;			/* o C^[tF[Xo[W */
	int i_directmes;	/*  䃁bZ[W̃A^Co 0:OFF 1:ON */
	int i_datatype;		/* o f[^t@C̃^Cv(OPI/OVI/OZI) */
	int i_result;		/* o  0:OK +:Warning -:Error */

	char *cp_indata;	/*  f[^AhX */
	char *cp_debugdata;	/*  fobOf[^ */
	char *cp_outdata;	/* o f[^AhX */
	int i_datalen;		/* o f[^TCY */

	int i_voiceconv;	/*  FRo[gL 0:OFF 1:ON */
	int i_nouse31;
	int i_nouse32;
	int i_nouse33;

	/* o̓obt@ 0:Messages */
	char *cps_out[DN_MAX_F2POUTBUFFER];
}T_F2PIF;

/* tRpCC֐ */
extern T_F2PIF __declspec(dllexport) *__stdcall f2pcv_dllmain( T_F2PIF * );
/* o͗̈֐ */
extern T_F2PIF __declspec(dllexport) *__stdcall f2pcv_dllfreem( T_F2PIF * );

#endif
#define F2PCVIF_H
